package org.pi3.servlet.samples;

import java.io.*;
import java.net.URL;
import java.net.MalformedURLException;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.Enumeration;

public class ContextServlet extends HttpServlet {
  public void doGet( HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException
    {
      String s;
      response.setContentType("text/html; charset=utf-8");
      StringBuffer sb = new StringBuffer("<H1>Context Servlet</H1>\r\n");
	sb.append("<p>This servlet engine supports <b>Servlet API Version ");
      sb.append(getServletContext().getMajorVersion());
      sb.append(".");
	sb.append(getServletContext().getMinorVersion());
      sb.append("</b>.<HR>\r\n");
	sb.append("<H2>ServletContext Methods</H2>");
	sb.append("<p><b>getRealPath(\"/images/\"): </b>" + getServletContext().getRealPath("/images/"));
	sb.append("<p><b>getMimeType(\"/images/Pi3Tile.gif\"): </b>" + getServletContext().getMimeType("/images/Pi3Tile.gif"));
	sb.append("<p><b>getServerInfo(): </b>" + getServletContext().getServerInfo());
	sb.append("<H2>Including Ressources</H2><HR>\r\n");
	
      URL url;
      try {
        sb.append("<p><b>Invocing getServletContext().getRessource(\"/index.html\"): </b>");
	  sb.append("<p>");
        url = getServletContext().getResource("/index.html");
	} catch (MalformedURLException e) {
	  return;
	};

      int rd = 0;
      byte[] buf = new byte[1024];

      if (url != null) {
	  InputStream ins = url.openStream();
        while (ins.available() != 0) {
          rd = ins.read(buf);
          if (rd > 0) {
            s = new String(buf, 0, rd);
            sb.append(s);
          } else {
            break;
          };
        };
      };

      sb.append("<p><b>Invocing getServletContext().getRessourceAsStream(\"/index.html\"): </b>");
      InputStream ins = getServletContext().getResourceAsStream("/index.html");
      while (ins.available() != 0) {
        rd = ins.read(buf);
        if (rd > 0) {
          s = new String(buf, 0, rd);
          sb.append(s);
        } else {
          break;
        };
      };

	s = sb.toString();
      response.setContentLength(s.length());
      ServletOutputStream out = response.getOutputStream();
      out.print(s);
      out.flush();
    }
  }